// -*- c++ -*-
/*
  Copyright 2003 John Knottenbelt
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#if !defined __CONNECTIONMANGER_H
#define __CONNECTIONMANGER_H

#include "select.h"
#include <list>

class Connection;

class ConnectionManager : public Selectable {
public:

  virtual ~ConnectionManager();

  void add(Connection *c);
  virtual void addSelectFDs(Select &s) const;
  virtual bool isReady(const Select &s) const;
  void processReady(Select &s);

  // Export the STL iterator
  typedef std::list<Connection *>::const_iterator const_iterator;
  const_iterator begin() const { return connections.begin(); }
  const_iterator end() const { return connections.end(); }

  bool removeJob(int job);

private:
  typedef std::list<Connection *> ConnectionList;
  ConnectionList connections;
};


#endif // __CONNECTIONMANGER_H
