// -*- c++ -*-
/*
  Copyright 2003 John Knottenbelt
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#if !defined __CONTROLLEDCONNECTION_H
#define __CONTROLLEDCONNECTION_H

#include "connection.h"

class ConnectionManager;

class ControlledConnection : public Connection {
public:
  ControlledConnection(TunerManager *tm, Scheduler *scheduler, 
		       ConnectionManager *cm,
		       int controlFD, int dataFD);

  virtual ~ControlledConnection();

  virtual void addSelectFDs(Select &) const;
  virtual bool isReady(const Select &) const;

  virtual bool processReady(const Select &s);

  virtual void notifyUnsubscribe(Source *s);

protected:
  virtual std::string getType() const;

private:
  void writeControl(const std::string &str);

  int controlFD;
  OutputBuffer *controlOutput;
  Scheduler *scheduler;
  InputBuffer *controlInput;
  ConnectionManager *cm;
};

#endif // __CONTROLLEDCONNECTION_H
